/* -*-mode:C++-*- */
/*
 * ksi_hash.h
 * hash tables
 *
 * Copyright (C) 1998-2000, Ivan Demakov.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without a written
 * agreement is hereby granted, provided that the above copyright notice
 * and this paragraph and the following two paragraphs appear in all copies.
 * Modifications to this software may be copyrighted by their authors
 * and need not follow the licensing terms described here, provided that
 * the new terms are clearly indicated on the first page of each file where
 * they apply.
 *
 * IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
 * FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
 * INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
 * DOCUMENTATION, EVEN IF THE AUTHORS HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAS NO OBLIGATIONS
 * TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 *
 *
 * Author:        Ivan Demakov <demakov@users.sourceforge.net>
 * Creation date: Tue Feb 17 18:42:42 1998
 * Last Update:   Mon Mar 20 21:27:08 2000
 *
 * 
 * $Id: ksi_hash.h,v 1.1.1.1 2000/07/25 19:10:31 demakov Exp $
 *
 */

#ifndef KSI_HASH_H
#define KSI_HASH_H

#include "ksi_vtab.h"


struct Ksi_Hashtab
{
  unsigned	itag;
  ksi_valtab	table;
  ksi_obj	hash;
  ksi_obj	cmp;
};

#define KSI_HASHTAB_P(x)	(KSI_OBJ_IS ((x), KSI_TAG_HASHTAB))
#define KSI_HASHTAB_TAB(x)	(((ksi_hashtab) (x)) -> table)
#define KSI_HASHTAB_HASH(x)	(((ksi_hashtab) (x)) -> hash)
#define KSI_HASHTAB_CMP(x)	(((ksi_hashtab) (x)) -> cmp)


ksi_obj
ksi_new_hashtab (int size, ksi_obj hash, ksi_obj cmp);


#endif

 /* End of file */
