/* -*-mode:C++-*- */
/*
 * ksi_mod.h
 * modules
 *
 * Copyright (C) 1997-2000, Ivan Demakov
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without a written agreement
 * is hereby granted, provided that the above copyright notice and this
 * paragraph and the following two paragraphs appear in all copies.
 * Modifications to this software may be copyrighted by their authors
 * and need not follow the licensing terms described here, provided that
 * the new terms are clearly indicated on the first page of each file where
 * they apply.
 *
 * IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY
 * FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
 * INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS
 * DOCUMENTATION, EVEN IF THE AUTHORS HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAS NO OBLIGATIONS
 * TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 *
 *
 * Author:        Ivan Demakov <demakov@users.sourceforge.net>
 * Creation date: Tue Oct 14 00:12:09 1997
 * Last Update:   Mon Mar 20 22:04:55 2000
 *
 * 
 * $Id: ksi_mod.h,v 1.1.1.1 2000/07/25 19:11:24 demakov Exp $
 *
 */

#ifndef KSI_MOD_H
#define KSI_MOD_H


struct Ksi_Module;

typedef struct Ksi_Module*	ksi_module;


struct Ksi_Module
{
  unsigned	itag;
  ksi_obj	env;
  ksi_obj	name;
  ksi_obj	export;
  ksi_obj	uses;
  ksi_obj	opts;
};

#define MOD_P(x)	KSI_OBJ_IS ((x), KSI_TAG_MODULE)
#define MOD_ENV(x)	(((ksi_module) (x)) -> env)
#define MOD_NAME(x)	(((ksi_module) (x)) -> name)
#define MOD_EXPORT(x)	(((ksi_module) (x)) -> export)
#define MOD_USES(x)	(((ksi_module) (x)) -> uses)
#define MOD_OPTS(x)	(((ksi_module) (x)) -> opts)


void
ksi_init_modules (void);

ksi_obj
ksi_module_p (ksi_obj x);

ksi_obj
ksi_make_module (ksi_obj name, ksi_obj export, ksi_obj opts, ksi_obj env);

ksi_obj
ksi_find_module (ksi_obj name);

ksi_obj
ksi_clear_module (ksi_obj module);

ksi_obj
ksi_current_module (void);

ksi_obj
ksi_set_current_module (ksi_obj mod);

ksi_obj
ksi_get_module_opt (ksi_obj mod, ksi_obj key);

ksi_obj
ksi_set_module_opt (ksi_obj mod, ksi_obj key, ksi_obj val);


#endif

 /* End of file */
